<?php
class ControllerStep1 extends Controller {
	private $error = array();
	
	public function index() {
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->redirect($this->url->http('step_2'));
		}

		$this->data['error_warning'] = @$this->error['warning'];
		
		$this->data['action'] = $this->url->http('step_1');

		$this->data['config_catalog'] = DIR_DANTOCART . 'config.php';
		$this->data['config_admin'] = DIR_DANTOCART . 'admin/config.php';
		
		$this->data['cache'] = DIR_DANTOCART . 'cache';
		$this->data['image'] = DIR_DANTOCART . 'image';
		$this->data['image_cache'] = DIR_DANTOCART . 'image/cache';
		$this->data['download'] = DIR_DANTOCART . 'download';

		$this->id       = 'content';
		$this->template = 'step_1.tpl';
		$this->layout   = 'layout';
		$this->render();
	}
	
	private function validate() {
		if (phpversion() < '5.0') {
			$this->error['warning'] = 'Warning: You need to use PHP5 or above for DantoCart to work!';
		}

		if (!ini_get('file_uploads')) {
			$this->error['warning'] = 'Warning: file_uploads needs to be enabled!';
		}
	
		if (!ini_get('allow_url_fopen')) {
			$this->error['warning'] = 'Warning: allow_url_fopen needs to be enabled!';
		}
	
		if (ini_get('session.auto_start')) {
			$this->error['warning'] = 'Warning: DantoCart will not work with session.auto_start enabled!';
		}

		if (!extension_loaded('mysql')) {
			$this->error['warning'] = 'Warning: MySQL extension needs to be loaded for DantoCart to work!';
		}

		if (!extension_loaded('gd')) {
			$this->error['warning'] = 'Warning: GD extension needs to be loaded for DantoCart to work!';
		}

		if (!extension_loaded('zlib')) {
			$this->error['warning'] = 'Warning: ZLIB extension needs to be loaded for DantoCart to work!';
		}
	
		if (!is_writable(DIR_DANTOCART . 'config.php')) {
			$this->error['warning'] = 'Warning: config.php needs to be writable for DantoCart to be installed!';
		}
				
		if (!is_writable(DIR_DANTOCART . 'admin/config.php')) {
			$this->error['warning'] = 'Warning: config.php needs to be writable for DantoCart to be installed!';
		}

		if (!is_writable(DIR_DANTOCART . 'cache')) {
			$this->error['warning'] = 'Warning: Cache directory needs to be writable for DantoCart to work!';
		}

		if (!is_writable(DIR_DANTOCART . 'image')) {
			$this->error['warning'] = 'Warning: Image directory needs to be writable for DantoCart to work!';
		}

		if (!is_writable(DIR_DANTOCART . 'image/cache')) {
			$this->error['warning'] = 'Warning: Image cache directory needs to be writable for DantoCart to work!';
		}
	
		if (!is_writable(DIR_DANTOCART . 'download')) {
			$this->error['warning'] = 'Warning: Download directory needs to be writable for DantoCart to work!';
		}
		
    	if (!$this->error) {
      		return TRUE;
    	} else {
      		return FALSE;
    	}
	}
}
?>